#include "hpscat.h"

char *pspro[] = {
  "%!",
  "%% Prologue for hpscat v1.3",
  "/D{bind def}bind def /MDP{makefont definefont pop}D",
  "/FF{findfont}D /FS{FF exch scalefont setfont}D",
  "/Ncour /Courier FF [.835 0 0 1 0 0] MDP",
  "/NBcour /Courier-Bold FF [.835 0 0 1 0 0] MDP",
  "/NF{/Ncour FS}D /BF{/NBcour FS}D",
  "/S{show}D /M{moveto}D /R{rlineto}D /L{setlinewidth}D",
  "/P{newpath}D /C{closepath}D /G{setgray}D /T{stroke}D /F{fill}D",
  ""
};

prologue()
{
    int  i=0;
    while(pspro[i][0]) fprintf(ofp,"%s\n", pspro[i++]);

#ifdef HPS
    fprintf(ofp,"/Nhangul /%s FF [1 0 0 .9 0 0] MDP\n", HFont);
    fprintf(ofp,"/HF{/Nhangul FS}D /H{%d HF}D\n", fsize);
#else
    fprintf(ofp,"/Nhangul1 /%s1 FF [1 0 0 .9 0 0] MDP\n", HFont);
    fprintf(ofp,"/Nhangul2 /%s2 FF [1 0 0 .9 0 0] MDP\n", HFont);
    fprintf(ofp,"/HF1{/Nhangul1 FS}D /H1{%d HF1}D\n", fsize);
    fprintf(ofp,"/HF2{/Nhangul2 FS}D /H2{%d HF2}D\n", fsize);
#endif
    fprintf(ofp,"/N{%d NF}D ", Defaultsize);
    if(efont==Bold)
        fprintf(ofp,"/E{%d BF}D\n", fsize);
    else
        fprintf(ofp,"/E{%d NF}D\n", fsize);
    fprintf(ofp,"%%%% EndProlog\n");
}


/**********************************
   simple i/f to PostScript
 **********************************/

moveto(x, y)
  int  x, y;
{
    fprintf(ofp,"%d %d M ", x, y);
}


setfont(fn, sc)
  char *fn;
  int  sc;
{
    fprintf(ofp,"%d /%s FS\n", sc, fn);
}


box(x, y, w, h)
  int  x, y, w, h;
{
    fprintf(ofp,"P %d %d M ", x, y);
    fprintf(ofp,"%d 0 R 0 %d R ", w, h);
    fprintf(ofp,"%d 0 R 0 %d R C\n", -w, -h);
    fprintf(ofp,".3 L T\n");
}

fillbox(x, y, w, h)
  int  x, y, w, h;
{
    fprintf(ofp,"P %d %d M ", x, y);
    fprintf(ofp,"%d 0 R 0 %d R ", w, h);
    fprintf(ofp,"%d 0 R C 0.9 G F 0 G\n", -w);
    box(x, y, w, h);
}

/***  EOF  ***/
